# Genesys Quality Management Suite 8.1.520 : Configuring Screen Capture in the Call Recording Settings

Created and last modified by

This chapter describes how to configure Screen Capture. The Screen Capture module tab is only visible if the Screen Capture service is selected during setup and the correct license with the Screen Capture module enabled is installed.

## Pre-requisites for Configuring Screen Capture in the Call Recording GUI

The following are required to ensure that Screen Capture functions properly:

1. The Screen Capture service must be running. To check that the Screen Capture service is running, view the output from `/opt/callrec/bin/callrec_status.`
2. The Call Recording license must include Screen Capture activation.
3. Agent IP phones must be paired to their PC IP addresses.
4. At least one recording rule must be defined with the Screen Capture checkbox selected, and a Screen Capture Usage (%) value above zero.

The remainder of the configuration continues to take place in the Call Recording Web GUI Settings > Configuration > Screen Capture tab:

- Specify quality and format settings on the Screen Capture Configuration page.
- Use the Screen Capture Communicator settings tab to set the main RMI address and the recording initiation/stopping selection.
- Use the Media Encoder settings tab to set audio and video mixing options.

After changing any settings click Save Configuration to save the settings.

## Configuring the Resolver

Navigate to Settings > Configuration > ScreenREC > ScreenREC.
Select a Filter method to determine desktop PC to IP telephone pairs. See the chapter on Configuring Screen Capture in the Call Recording Settings. If a dynamic XML based web service for setting pairs is used, consult the Support team at Genesys Tech Support.

After changing any settings click Save Configuration to save the settings.

## Configuring the Registry address

Navigate to Settings > Configuration > ScreenREC > ScreenREC.

Screen Capture Registry address sets standard binding information. Select the server where Screen Capture is running. Servers are defined in the Call Recording Servers tab.

After changing any settings click Save Configuration to save the settings.

## Configuring the Output File and Uploader Settings

Navigate to Settings > Configuration > ScreenREC > ScreenREC.

These settings relate to the Media Upload Server (MUS).

- Location in filesystem is the path to the directory containing intermediate (.recd) screen capture files.
  If Screen Capture is installed as part of a single Genesys Quality Management Suite server, this path is the same as the path used in database setting, for example, `/opt/callrec/data/calls.`
  In a Screen Capture cluster scenario, where the Media Upload Server (MUS) is installed on a separate server, this setting is the full mount path from the MUS server to the remotely mounted Call Recording Core file system directory, for example, `/mnt/core/opt/callrec/data/calls.`
- Path used by database: internal path to directory containing intermediate (`.recd`) screen capture.
  This remains the same whether a standalone or cluster installation is used, for example, `/opt/callrec/data/calls.`
- Directory pattern: the template for creating subfolders in the storage directory. By default Call Recording stores calls in a new folder every day, the default template `yyyyMMdd` means that recordings from 24.12.2009 are stored in a folder named `20091224`. If this setting is changed in Call Recording, update this template to match your setting.
- Date pattern: use this template for customizing the date format. Default: empty. The Date pattern setting is not necessary for most Call Recording installations, since it overrides the standard date template. Leave this field blank.

## Configuring the Uploader Settings

Navigate to Settings > Configuration > ScreenREC > ScreenREC.

Uploader address: the Screen Capture Media Uploader Server can be selected if different to the Core server, the server can be defined in the Call Recording Core settings in the Web GUI. Note that the MUS must be mapped to the Core server file system, the file paths must point to the same location.

## Configuring the Recording Specifications

Navigate to Settings > Configuration > ScreenREC > ScreenREC.

The Recording Specifications settings affect screen capture quality.

- Frames per second: [default: 2] The number of frames per second. Value can be in the range 0.5 – 5. A higher value results in smoother animation, but much greater demands on system resources (encoder processor load, file storage).
- Maximum uploading bandwidth: [default: No Limit]. A method of restricting the bandwidth used by the Screen Capture Capture Client (SCC). A lower speed value reduces bandwidth, but slows upload operations. Value range: 96kb/s – 1024kb/s. The value No Limit cancels this restriction.
- Maximum recording length: [default: `0` = no limit]. A value, in seconds, formatted as `hh:mm:ss`, after which all recordings are terminated. A range of `0 – 23:59:59` is permitted; the value of 0 cancels this restriction.
- Recorded screens: [default: All] Record one (Primary Only) or All monitors and displays that are connected to the computer.
- Scale factor: [default: Do not scale]: Affects scaling. Value can be between 20% and 75% (50% corresponds to a final video screen size 50% smaller than the original screen, which reduces bandwidth requirements and stored file size). Small details can be lost in down-scaled screen recordings.
- Captured screen quality: [default: High]: Parameter for output of JPEG compression. Value can be within the range Maximum – Low. Typically it is set to a value of High. A lower quality value corresponds to a lower bandwidth required from SCC to MUS, but results in reduced capture quality.
- Timeout in seconds: [default: `10`]: Upload timeout for Screen Capture Capture Client (SCC) before a new file is created (in the event of network issues etc.). Possible range is `1 –60` seconds.

## Advanced Recording Specifications

The advanced recording specifications provide additional flexibility in configuring SCC performance:

Navigate to Settings > Configuration > ScreenREC > ScreenREC.

- Regions size: [default: Balanced]: dictates how the screen recording regions are defined.
  Prefer lower bandwidth: smaller regions requiring less bandwidth but more encoder processing.
  Balanced: a compromise achieving reasonable encoder performance and medium bandwidth requirements.
  Prefer encoder performance: larger regions requiring more bandwidth, but enabling the best encoder performance.

## Configuring Thumbnail Screen Captures for Live Monitoring

Navigate to Settings > Configuration > ScreenREC > ScreenREC scroll down.

The default settings for recording thumbnails upload a new thumbnail every five seconds at high quality. These settings provide the optimum balance for most installations.

Where there is limited bandwidth it is possible to:

Deselect the Enable thumbnails checkbox to disable the thumbnails entirely.

Increase the Refresh period in seconds to a higher value. Setting a longer refresh period makes the intervals between new thumbnails longer and so they use less bandwidth. The refresh period range is from 1-60 seconds.

Reduce the Quality of the thumbnails. The choices are Maximum, High, Normal and Low the default setting is High. Reducing the Quality setting to Normal or Low uses less bandwidth.

After changing any settings click Save Configuration to save the settings.

## Configuring the Uploader Global Settings

Navigate to Settings > Configuration > Screen Capture > Screen Capture.

These settings are global, for all Screen Capture Media Upload (MUS) servers added on this configuration screen. For this reason, these settings are found at the very bottom of the page.

Upload directory: The global upload directory location for Media Upload Server (MUS) configuration. For a single Genesys Quality Management Suite server, this path should be the same as the Location in filesystem setting in the Output Files Settings section above.

For the correct settings and procedures for a clustered Screen Capture installation, contact Genesys Tech Support.

Enable live stream is enabled by default. Deselecting this disables both Screen monitoring and thumbnails.

Thumbnails cached for (seconds) the default is 20 seconds. This means that in the absence of a new thumbnail Live Monitoring will display the current one for 20 seconds. The Cache period range is from 1-60 seconds.

After changing any settings click Save Configuration to save the settings.

## Pairing Screen Capture Agents to Their Desktops

Each agent’s desktop PC and IP phone must be associated (paired) to each other; a process known as ‘resolution’. This setting then tells Screen Capture which desktop to record when a call is initiated. There are four different methods of configuration, depending on the Filter setting:

- Option 1: XML Resolver
- Option 2: Agent ID Resolver
- Option 3: Property Resolver
- Option 4: IP to IP Resolver

### Option 1 - XML Resolver

This is the simplest option, suitable for a small number of Screen Capture enabled agents. On the configuration screen, use the default XML resolver to associate agent IPs and phones.

Navigate to Settings > Configuration > ScreenREC > ScreenREC.

1. In the Filter drop-down list, select XML Resolver.
2. Click New.
3. Enter the Phone extension or IP address, and IP PC hostname or IP address, for an agent. Repeat this until all agents’ phone and IP information are entered.
4. Click Save configuration.

Each mapping that pairs a phone extension to a PC IP address must be unique for Screen Capture to operate correctly.

### Option 2 - Agent ID Resolver

Navigate to Settings > Configuration > ScreenREC > ScreenREC.

The Agent ID resolver can only be used with Call Recording installations incorporating one of the following Contact Center integration components:

- Genesys Active Recording Ecosystem
- Genesys Enhanced Passive Recording (EPR)
- Genesys Integration Module

The Windows login ID on the Agent's PC is matched with the Agent's Contact Center login ID, obtained as external data by the SRS from the Call Recording integration component.

### Option 3 – Property Resolver

To specify a large number of pairs, the use of a separate configuration file can be easier to maintain. This file is located on the Call Recording server, or can be created, at the following location:

    /opt/callrec/screenrec/properties/cz/zoom/callrec/srs/addresses.properties

Each pair can be any combination of IP address, hostname, or phone extension; for example, IP address to hostname, extension to IP address, extension to hostname, and so on. However, a pair consisting of a desktop IP address and an agent extension number must be unique. Screen Capture does not operate correctly if more than one extension number is paired to the same desktop IP address.

Use a separate line for each pair, for example, if the agent’s IP phone is `192.168.50.12` and the agent’s desktop PC IP address is `192.168.110.32`, enter:

    192.168.50.12=192.168.110.32

If the desktop IP and phone IP are identical, for example, if the agent is using a software IP phone, enter the same IP address twice:

    192.168.110.50=192.168.110.50

If all Screen Capture enabled agents are using the same IP address for both desktop PC and IP phone, see the next option: IP to IP resolver.

After updating the addresses.properties file, select the Property resolver filter option in the Screen Capture Resolver configuration, then restart Screen Capture.

Use the command:

    /opt/callrec/bin/rc.callrec_screenrec restart

### Option 4 – IP to IP Resolver

If all agent pairs use the same IP address for both desktop PC and IP phone (as in all agents use a software IP phone), this option may be the most appropriate. If screen capture is requested according to the recording rules, Call Recording automatically attempts to contact the Screen Capture Capture Client using the same IP address as for the agent’s IP phone.

The IP to IP Resolver supports:

- Cisco SCCP
- Cisco JTAPI + SPAN
- Cisco JTAPI SPANless
- SIP
- Genesys Driver in EPR mode

The IP to IP Resolver does not support, Genesys Driver in MSR (Active Recording Ecosystem) mode or Avaya.
These two platforms do not supply the required information about the phone's IP address.

## Screen Capture Communicator Settings

Navigate to Settings > Configuration > ScreenREC > ScreenREC Communicator.

The Screen Capture Communicator is configured with the following settings:

Registry address: the server running the RMI service.

Stop Setting: the method of determining the end of the screen capture. Depending on this setting, the remaining fields change as follows:

OnEndCouple Stop

- Stop Setting: OnEndCouple stop: stops at the end of the associated audio call.
- Stop recording after delay (seconds): specify any additional delay before stopping.
- Wait for Agent ID in external data: the Communicator only stops when the Agent ID is found in at least one of the indicated external data fields (External Data name for Agent ID of the calling party / External Data name for Agent ID of the called party).

OnExternalData Stop

- Stop Setting: OnExternalData stop Screen capture stops when a particular external data key is received after the call ends.
- Name of external data: specify the name of the data key to be found.
- Max waiting time for external data (seconds): timeout value for external data key. After the call ends, if the specified key is not found in the external data within this time period, screen capture stops automatically.

This feature is not yet supported by the Genesys platform.

## Configuring the Media Encoder

Navigate to Settings > Configuration > ScreenREC > Media Encoder.

The Screen Capture Media Encoder is configured with the following parameters:

### Database Setting

- Database Pool: the database pool to use for the Media Encoder; usually `callrec` on a single server.

### Application Communicator

- Registry address: the server running the RMI service (core on a single server).

### Mixer Task Settings

- Schedule task run: when checked, the Media Encoder performs batch encoding of capture files at regular intervals. When unchecked, the Media Encoder functions on demand only, on the command line or selecting a capture file to export in the list of call recordings in the Call Recording Web GUI.
- Run period in minutes: determines the wait period for the Media Encoder when no calls are queued for encoding.
- Range of processed calls: defines the time range of the calls for encoding. In some cases it is important not to process recordings right after they are saved, in which case this parameter enables you to define that only recordings older than x minutes get processed. Use a variable time window, since it speeds up the selection of recordings from the database.

### Encoder Settings

The following settings are assigned to each individual Encoder. After Genesys Quality Management Suite installation, only one Master Encoder is defined, but more can be added if required.

- Media Encoder Name: a user defined name for this Encoder.
- Is Master?: specify by selecting this option that this is a Master Encoder.
- Load Balancer Weight: relative weight / priority compared to other Encoders.
- Registry address: the server running the RMI service.
- Location in filesystem: path to directory containing both intermediate (`.recd`) screen capture (input) files and the encoded files output by the Media Encoder.
  If Screen Capture is installed as part of a single (standalone) Genesys Quality Management Suite server, this path is the same as the Path used in the database setting:
  For example, `/opt/Call Recording/data/calls`.

In a Screen Capture cluster scenario, where the Screen Capture Media Encoder (SME) is installed and configured on a separate server to the database, this setting is the full mount path from the SME server to the remotely mounted Call Recording Core file system directory:
For example `/mnt/core/opt/callrec/data/calls`.

- Path used in database – Internal path (prefix) to directory containing both intermediate (.recd) screen capture (input) files and the encoded files output by the Media Encoder:
  For example `/opt/callrec/data/calls`.
  This value is checked by the Screen Capture Media Encoder (SME) in order to resolve the complete file system path to the directory specified in the location in filesystem parameter:
  If the current path prefix found in the database is the same as the path used in database parameter prefix, the SME replaces the prefix found in the database with that found in the location in filesystem parameter. This is typically used in a Screen Capture cluster scenario, where the SME(s) and database are on different servers.
  If the current path prefix found in the database is different to the path used in database parameter prefix, including if left blank, the SME uses the prefix found in the database unchanged. This is typically the case with single server scenarios.

- If the Relocation Tool is scheduled to move recd data files to a custom directory elsewhere, that directory must be writable by Call Recording (for example, by using the chown tool:

      chown -R callrec:callrec /path/to/custom/directory)

  The Screen Capture Media Encoder writes encoded mp4 video files to the same directory as the source recd files, so this fails with the default permissions assigned by the Relocation Tool.

- Remove unmixed files after mixing: If selected, the original intermediate format files (.recd) are deleted after mixing. By default, this option is not checked, so all source files are retained. This assumes that a media lifecycle policy (archive/delete) are applied to the directories specified by the path to calls to be processed and the path to save the encoded file parameters above.

- Video Codec [default: H.264]: Video codec for encoded video, either H.264 or MPEG 4:2.

- Key frame rate in seconds [default: 5]: Value (in seconds) specifying how often to force a key frame in the output video; value range: 1 – 60

- Encoded video quality (bitrate) [default: High]: Quality of encoded video for playback; value range between Maximum and Low. Maximum quality utilizes the most system resources.

### Configuring a Custom Temporary Directory for the Media Encoder

For reasons of performance, by default the media encoder is set up to use the system tmp directory. Many other applications use the existing system tmp directory to store information. Files marked for deletion, but not yet deleted, can use up vital space. This can lead to insufficient space for the media encoder to process large video files, and in severe cases, the media encoder stops encoding. The solution is to give the media encoder its own temporary directory independent of the system tmp directory.

Step 1

Specify a different temporary directory for the mixer module by adding the mixer parameters line at the end of `/opt/callrec/etc/callrec`.derived configuration file as follows:

    JAVA_OPTS_MIXER="-server -Xms32m -Xmx1024m -DTMPDIR=/opt/callrec/tmp"

Step 2

Restart the configuration service, then the mixer module:

    /opt/callrec/bin/rc.callrec_configmanager restart
    /opt/callrec/bin/rc.callrec_mixer restart